/*
* SHA-1 in C
* By Steve Reid <steve@edmweb.com>
* 100% Public Domain
*/

#ifndef _SHA1_H_
#define _SHA1_H_

#define	AMD_SHA1_BLOCK_LENGTH		64
#define	AMD_SHA1_DIGEST_LENGTH		20

typedef struct {
  uint32_t	state[5];
  uint64_t	count;
  unsigned char	buffer[AMD_SHA1_BLOCK_LENGTH];
} AMD_SHA1_CTX;

void AMD_SHA1Init(AMD_SHA1_CTX * context);
void AMD_SHA1Transform(uint32_t state[5], const unsigned char buffer[AMD_SHA1_BLOCK_LENGTH]);
void AMD_SHA1Update(AMD_SHA1_CTX *context, const unsigned char *data, unsigned int len);
void AMD_SHA1Final(unsigned char digest[AMD_SHA1_DIGEST_LENGTH], AMD_SHA1_CTX *context);

#endif /* _SHA1_H_ */
